summaryrefslogtreecommitdiffstats
path: root/tests/qemu-iotests/160
diff options
context:
space:
mode:
authorReda Sallahi2016-08-10 16:16:09 +0200
committerMax Reitz2016-09-20 22:10:57 +0200
commitf7c1553388c98efcdcc70371e655417cf1ed7df6 (patch)
treeafc25b05e013b671d704c4948306c4315dee5af1 /tests/qemu-iotests/160
parentqemu-img: add the 'dd' subcommand (diff)
downloadqemu-f7c1553388c98efcdcc70371e655417cf1ed7df6.tar.gz
qemu-f7c1553388c98efcdcc70371e655417cf1ed7df6.tar.xz
qemu-f7c1553388c98efcdcc70371e655417cf1ed7df6.zip
qemu-img: add skip option to dd
This adds the skip option which allows qemu-img dd to skip a number of blocks before copying the input. A test case was added to test the skip option. Signed-off-by: Reda Sallahi <fullmanet@gmail.com> Message-id: 20160810141609.32727-1-fullmanet@gmail.com Signed-off-by: Max Reitz <mreitz@redhat.com>
Diffstat (limited to 'tests/qemu-iotests/160')
-rwxr-xr-xtests/qemu-iotests/16072
1 files changed, 72 insertions, 0 deletions
diff --git a/tests/qemu-iotests/160 b/tests/qemu-iotests/160
new file mode 100755
index 0000000000..5c910e5bfc
--- /dev/null
+++ b/tests/qemu-iotests/160
@@ -0,0 +1,72 @@
+#! /bin/bash
+#
+# qemu-img dd test for the skip option
+#
+# Copyright (C) 2016 Reda Sallahi
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+owner=fullmanet@gmail.com
+
+seq="$(basename $0)"
+echo "QA output created by $seq"
+
+here="$PWD"
+status=1
+
+_cleanup()
+{
+ _cleanup_test_img
+ rm -f "$TEST_IMG.out" "$TEST_IMG.out.dd"
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+. ./common.rc
+. ./common.filter
+. ./common.pattern
+
+_supported_fmt raw
+_supported_proto file
+_supported_os Linux
+
+TEST_SKIP_BLOCKS="1 2 30 30K"
+
+for skip in $TEST_SKIP_BLOCKS; do
+ echo
+ echo "== Creating image =="
+
+ size=1M
+ _make_test_img $size
+ _check_test_img
+ $QEMU_IO -c "write -P 0xa 24 512k" "$TEST_IMG" | _filter_qemu_io
+
+ echo
+ echo "== Converting the image with dd with skip=$skip =="
+
+ $QEMU_IMG dd if="$TEST_IMG" of="$TEST_IMG.out" skip="$skip" -O "$IMGFMT" \
+ 2> /dev/null
+ TEST_IMG="$TEST_IMG.out" _check_test_img
+ dd if="$TEST_IMG" of="$TEST_IMG.out.dd" skip="$skip" status=none
+
+ echo
+ echo "== Compare the images with qemu-img compare =="
+
+ $QEMU_IMG compare "$TEST_IMG.out.dd" "$TEST_IMG.out"
+done
+
+echo
+echo "*** done"
+rm -f "$seq.full"
+status=0